



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python学习--22 异步I/O</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python学习--22 异步I/O</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-27 00:15:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>在同步IO中，线程启动一个IO操作然后就立即进入等待状态，直到IO操作完成后才醒来继续执行。而异步IO方式中，线程发送一个IO请求到内核，然后继续处理其他的事情，内核完成IO请求后，将会通知线程IO操作完成了。</p></blockquote>
<blockquote><p>如果IO请求需要大量时间执行的话，异步IO方式可以显著提高效率，因为在线程等待的这段时间内，CPU将会调度其他线程进行执行，如果没有其他线程需要执行的话，这段时间将会浪费掉。</p></blockquote>
<h2>协程</h2>
<p>协程（Coroutine），又称微线程。</p>
<p>我们平常使用的函数又称子程序，是层级调用的，即A函数调用B，B函数又调用C，那么需要等C执行完毕返回，然后B程序执行完毕返回，最后A执行完毕。</p>
<p>协程看上去也是子程序，但是执行顺序和子程序不同：协程执行过程可以中断，同样是A函数调用B，但B可以执行一部分继续去执行A，然后继续执行B未执行完的部分。</p>
<p>协程看起来很像多线程。但协程最大的优势是极高的执行效率。因为线程需要互相切换，切换需要开销。且线程直接共享变量需要使用锁机制，因为协程只有一个线程，不存在同时写变量冲突。</p>
<p>Python对协程的支持是通过generator实现的。</p>
<p>在generator中，我们不但可以通过for循环来迭代，还可以不断调用<code>next()</code>函数获取由<code>yield</code>语句返回的下一个值。</p>
<p>但是Python的<code>yield</code>不但可以返回一个值，它还可以接收调用者发出的参数。下面是一个典型的<code>生产者-消费者</code>模型：</p>
<pre class="prettyprint linenums"><code># coding: utf-8

def consumer():<br />
    r = ''<br />
    while True:<br />
        n = yield r<br />
        print('[Consumer] Consuming %s' % n)<br />
        r = '200 OK'

def produce(c):<br />
    c.send(None) #启动生成器<br />
    i = 0<br />
    while i &lt; 5:<br />
        i = i + 1<br />
        print('[Produce] Start produce %s' % i)<br />
        r = c.send(i)<br />
        print('[Produce] Consumer return  %s' % r)

c = consumer() #生成器<br />
produce(c)<br />
</code></pre>
<p>输出：</p>
<pre class="prettyprint linenums"><code>[Produce] Start produce 1<br />
[Consumer] Consuming 1<br />
[Produce] Consumer return  200 OK<br />
[Produce] Start produce 2<br />
[Consumer] Consuming 2<br />
[Produce] Consumer return  200 OK<br />
[Produce] Start produce 3<br />
[Consumer] Consuming 3<br />
[Produce] Consumer return  200 OK<br />
[Produce] Start produce 4<br />
[Consumer] Consuming 4<br />
[Produce] Consumer return  200 OK<br />
[Produce] Start produce 5<br />
[Consumer] Consuming 5<br />
[Produce] Consumer return  200 OK<br />
</code></pre>
<blockquote><p>执行顺序：<br /><br />
1、发送None启动生成器consumer()，运行yield r，返回''，程序中断；<br /><br />
2、第2次发送1，从上次运行结束的地方开始，先通过n = yield r接收到1，继续运行打印语句，再次运行到yield r，返回'200 OK'；<br /><br />
3、第3次发送2，从上次运行结束的地方开始，先通过n = yield r接收到2，继续运行打印语句，再次运行到yield r，返回'200 OK'；<br /><br />
4、...</p></blockquote>
<p>大家可以使用 <a href="http://www.cnblogs.com/Bowu/p/4026117.html" rel="external nofollow noreferrer">Intellij IDEA调试功能</a> 进行单步运行观察执行流程。</p>
<p>整个流程由一个线程执行，produce和consumer协作完成任务，所以称为“协程”，而非线程的抢占式多任务。</p>
<h2>asyncio</h2>
<p><code>asyncio</code>是Python 3.4版本引入的标准库，直接内置了对异步IO的支持。使用<code>asyncio</code>可以实现单线程并发IO操作。</p>
<p><code>@asyncio.coroutine</code>把一个generator标记为coroutine类型：</p>
<pre class="prettyprint linenums"><code># coding: utf-8<br />
import asyncio

@asyncio.coroutine<br />
def helloWorld(n):<br />
    print('Hello world! %s' % n)<br />
    r = yield from asyncio.sleep(3)<br />
    print('Hello %s %s ' % (r, n))

loop = asyncio.get_event_loop()<br />
tasks = [helloWorld(1), helloWorld(2), helloWorld(3), helloWorld(4)]<br />
loop.run_until_complete(asyncio.wait(tasks))<br />
loop.close()<br />
</code></pre>
<p>输出：</p>
<pre class="prettyprint linenums"><code>Hello world! 2<br />
Hello world! 3<br />
Hello world! 1<br />
Hello world! 4

#(等待3秒左右)

Hello None 2<br />
Hello None 1<br />
Hello None 3<br />
Hello None 4<br />
</code></pre>
<p>程序先运行<code>Hello world! </code>，然后由于<code>asyncio.sleep()</code>也是一个coroutine，线程不会等待<code>asyncio.sleep()</code>，而是直接中断并执行下一个消息循环。当<code>asyncio.sleep()</code>返回时，线程就可以从<code>yield from</code>拿到返回值（此处是<code>None</code>），然后接着执行下一行语句。</p>
<blockquote><p><code>asyncio</code>的编程模型就是一个消息循环。我们从<code>asyncio</code>模块中直接获取一个<code>EventLoop</code>的引用，然后把需要执行的协程扔到<code>EventLoop</code>中执行，就实现了异步IO。</p></blockquote>
<h2>async/await</h2>
<p>用asyncio提供的<code>@asyncio.coroutine</code>可以把一个<code>generator</code>标记为<code>coroutine</code>类型，然后在<code>coroutine</code>内部用<code>yield from</code>调用另一个<code>coroutine</code>实现异步操作。</p>
<p>为了简化并更好地标识异步IO，从Python 3.5开始引入了新的语法<code>async</code>和<code>await</code>，可以让<code>coroutine</code>的代码更简洁易读。</p>
<p>请注意，<code>async</code>和<code>await</code>是针对<code>coroutine</code>的新语法，要使用新的语法，只需要做两步简单的替换：</p>
<ol><li>把<code>@asyncio.coroutine</code>替换为<code>async</code>；</li>
<li>把<code>yield from</code>替换为<code>await</code>。</li></ol>
<p>上节的代码用Python3.5写：</p>
<pre class="prettyprint linenums"><code># coding: utf-8<br />
import asyncio

async def helloWorld(n):<br />
    print('Hello world! %s' % n)<br />
    r = await asyncio.sleep(3)<br />
    print('Hello %s %s ' % (r, n))

loop = asyncio.get_event_loop()<br />
tasks = [helloWorld(1), helloWorld(2), helloWorld(3), helloWorld(4)]<br />
loop.run_until_complete(asyncio.wait(tasks))<br />
loop.close()<br />
</code></pre>
<h2>aiohttp</h2>
<p><code>aiohttp</code>是基于<code>asyncio</code>实现的HTTP框架。</p>
<p>需要先安装：</p>
<pre class="prettyprint linenums"><code>$ pip install aiohttp<br />
</code></pre>
<p>控制台输出：</p>
<pre class="prettyprint linenums"><code>Collecting aiohttp<br />
  Downloading aiohttp-1.3.1-cp34-cp34m-win32.whl (147kB)<br />
    100% |████████████████████████████████| 153kB 820kB/s<br />
Collecting async-timeout&gt;=1.1.0 (from aiohttp)<br />
  Downloading async_timeout-1.1.0-py3-none-any.whl<br />
Collecting yarl&gt;=0.8.1 (from aiohttp)<br />
  Downloading yarl-0.9.6-cp34-cp34m-win32.whl (77kB)<br />
    100% |████████████████████████████████| 81kB 1.8MB/s<br />
Collecting chardet (from aiohttp)<br />
  Downloading chardet-2.3.0-py2.py3-none-any.whl (180kB)<br />
    100% |████████████████████████████████| 184kB 890kB/s<br />
Collecting multidict&gt;=2.1.4 (from aiohttp)<br />
  Downloading multidict-2.1.4-cp34-cp34m-win32.whl (133kB)<br />
    100% |████████████████████████████████| 143kB 3.3MB/s<br />
Installing collected packages: async-timeout, multidict, yarl, chardet, aiohttp<br />
Successfully installed aiohttp-1.3.1 async-timeout-1.1.0 chardet-2.3.0 multidict-2.1.4 yarl-0.9.6<br />
</code></pre>
<p>说明安装完成。</p>
<p>示例：</p>
<pre class="prettyprint linenums"><code># coding: utf-8<br />
import asyncio<br />
from aiohttp import web

@asyncio.coroutine<br />
def index(request):<br />
    return web.Response(body=b'Hello aiohttp!', content_type='text/html')

@asyncio.coroutine<br />
def user(request):<br />
    name = request.match_info['name']<br />
    body = 'Hello %s' % name<br />
    return web.Response(body=body.encode('utf-8'), content_type='text/html')<br />
    pass

@asyncio.coroutine<br />
def init(loop):<br />
    # 创建app<br />
    app = web.Application(loop=loop)

    #添加路由<br />
    app.router.add_route('GET', '/', index)<br />
    app.router.add_route('GET', '/user/{name}', user)

    #运行server<br />
    server = yield from loop.create_server(app.make_handler(), '127.0.0.1', 9999)<br />
    print('Server is running at http://127.0.0.1:9999 ...')

loop = asyncio.get_event_loop()<br />
loop.run_until_complete(init(loop))<br />
loop.run_forever()<br />
</code></pre>
<p>运行程序：</p>
<pre class="prettyprint linenums"><code>$ python user_aiohttp.py

Server is running at http://127.0.0.1:9999 ...<br />
</code></pre>
<p>浏览器依次输入查看效果：<br /><br />
<a href="http://127.0.0.1:9999/" rel="external nofollow noreferrer">http://127.0.0.1:9999/</a><br /><br />
<a href="http://127.0.0.1:9999/user/aiohttp" rel="external nofollow noreferrer">http://127.0.0.1:9999/user/aiohttp</a></p>
<p>更多知识可以查看aiohttp文档：<br /><br />
<a href="http://aiohttp.readthedocs.io/en/stable/" rel="external nofollow noreferrer">http://aiohttp.readthedocs.io/en/stable/</a></p>
<blockquote><p>参考：<br /><br />
1、Python asyncio库的学习和使用<br /><br />
<a href="http://www.cnblogs.com/rockwall/p/5750900.html" rel="external nofollow noreferrer">http://www.cnblogs.com/rockwall/p/5750900.html</a><br /><br />
2、异步IO<br /><br />
<a href="http://www.liaoxuefeng.com/wiki/0014316089557264a6b348958f449949df42a6d3a2e542c000/00143208573480558080fa77514407cb23834c78c6c7309000" rel="external nofollow noreferrer">http://www.liaoxuefeng.com/wiki/0014316089557264a6b348958f449949df42a6d3a2e542c000/00143208573480558080fa77514407cb23834c78c6c7309000</a></p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495ggxvq.html">使用java反射机制编写Student类并保存</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn5dm3q.html">eclipse中mybatis&lowbar;generator插件的安装与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z4o4d9.html">【转】C&num;调用DLL</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kr4z6q.html">设置MySQL服务自动运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q74xgjq.html">一个简单例子：贫血模型or领域模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zvkm69.html">Mac 平台下功能强大的Shimo软件使用指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mnme1q.html">创建透明的UIToolbar</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j024egq.html">ubuntu服务器&sol;home&sol;分区替换3T硬盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxng63z8.html">SDUTRescue The Princess（数学问题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x4mlr9.html">关于keil单片机编程中的data&comma;idata&comma;xdata&comma;pdata&comma;code数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmo0ye9.html">时刻注意QT与Windows系统的不同（惨痛教训）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmooe49.html">ie6下a标签的onclick事件不执行问题解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjkwox8.html">定义一个Matrix类，实现矩阵的加法和乘法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k62m69.html">treeview调用数据库成树</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m37x38.html">Android 沉浸式状态栏攻略 让你的状态栏变色吧</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pv3vj8.html">python正则表达式--分组、后向引用、前&lpar;后&rpar;向断言</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj1km09.html">使用EasyPOI导出excel示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2261oq.html">for循环输出空心菱形的形状【java】</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r2l4j9.html">【Linux基础】history查看历史命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m261zoq.html">阅读《深入应用C&plus;&plus;11：代码优化与工程级应用》</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90mjye48.html">address2line 定位 Android c&plus;&plus;奔溃位置</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mjywm8.html">PHP7新特性</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpdgwvq.html">SVN打基线</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpnl539.html">【WebStorm】前端工具开发利器webstrom专篇&period;&period;&period;更新中</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojvwy5q.html">Zepto&period;js-Ajax 请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkojde8.html">Windows与Linux文件系统互访的几种方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zorn3vq.html">Pomelo框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/950mkke8.html">Flex移动应用程序开发的技巧和窍门&lpar;四&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1zyvjq.html">Canvas globalCompositeOperation API</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj5g1r8.html">JS可维护性代码</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
